Index: src/edu/ucsb/nceas/metacat/ReplicationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ReplicationHandler.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/ReplicationHandler.java	(revision 1217)
@@ -57,7 +57,7 @@
   int serverCheckCode = 1;
   MetaCatUtil util = new MetaCatUtil();
   Hashtable serverList = new Hashtable(); 
-  Connection conn;
+  //Connection conn;
   PrintWriter out;
   
   public ReplicationHandler(PrintWriter o)
@@ -82,13 +82,13 @@
     //xml_documents with an update_date > last_checked
     try
     {
-      try
-      { //this connection is prone to error for some reason so we 
+      //try
+      //{ //this connection is prone to error for some reason so we 
         //try to connect it three times before quiting.
-        conn = util.openDBConnection();
-      }
-      catch(SQLException sqle)
-      {
+        //conn = util.openDBConnection();
+      //}
+      //catch(SQLException sqle)
+      //{
         /*try
         {
           conn = util.openDBConnection();
@@ -101,13 +101,13 @@
           }
           catch(SQLException sqleee)
           {*/
-            System.out.println("error getting db connection in " + 
-                               "ReplicationHandler.run: " +
-                               sqle.getMessage());
+            //System.out.println("error getting db connection in " + 
+                               //"ReplicationHandler.run: " +
+                               //sqle.getMessage());
           //}
         //}
-      }
-      serverList = buildServerList(conn);
+      //}
+      serverList = buildServerList();
       //if serverList is null, metacat don't need to replication
       if (serverList==null||serverList.isEmpty())
       {
@@ -115,12 +115,13 @@
       }
       updateCatalog(serverList);
       update(serverList);
-      conn.close();
-    }
+      //conn.close();
+    }//try
     catch (Exception e)
     {
-      //System.out.println("Error in replicationHandler.run():"+e.getMessage());
-    }
+      MetaCatUtil.debugMessage("Error in replicationHandler.run():"
+                                                    +e.getMessage(), 30);
+    }//catch
   }
   
   /**
@@ -142,8 +143,9 @@
        should be kept anyway)
     */
     
-    Connection conn = null;
-    try
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    /*try
     {
       conn = util.getConnection();
     }
@@ -150,7 +152,7 @@
     catch (Exception e)
     {
       util.debugMessage("There is problem to get conncetion: "+e.getMessage());
-    }
+    }*/
     
     Enumeration keys;
     String server;
@@ -168,6 +170,9 @@
     
     try
     {
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.update");
+      serialNumber=dbConn.getCheckOutSerialNumber();
       MetaCatUtil.debugMessage("init parser");
       parser = initParser(message);
       keys = serverList.keys();
@@ -235,7 +240,7 @@
           String docServer = (String)w.elementAt(2);
           
     
-          pstmt = conn.prepareStatement("select rev from xml_documents where "+
+         pstmt = dbConn.prepareStatement("select rev from xml_documents where "+
                                         "docid like '" + docid + "'");
           pstmt.execute();
           rs = pstmt.getResultSet();
@@ -292,7 +297,7 @@
             try
             {
              
-              String newDocid = DocumentImpl.writeReplication(conn, 
+              String newDocid = DocumentImpl.writeReplication(dbConn, 
                               new StringReader(newxmldoc),
                               (String)docinfoHash.get("public_access"),
                               null,  /* the dtd text */
@@ -302,6 +307,8 @@
                               null, /* null for groups[] */
                               docHomeServer, 
                               false /* validate */);
+              //increase usage
+              dbConn.increaseUsageCount(1);
               MetacatReplication.replLog("wrote doc " + docid + " from " + 
                                          docServer);
               /*System.out.println("wrote doc " + docid + " from " + 
@@ -379,7 +386,7 @@
         { //delete the deleted documents;
           Vector w = new Vector((Vector)d.elementAt(k));
           String docid = (String)w.elementAt(0);
-          if(!alreadyDeleted(docid, conn))
+          if(!alreadyDeleted(docid))
           {
           
             //because delete method docid should have rev number
@@ -386,7 +393,7 @@
             //so we just add one for it. This rev number is no sence.
             String accnum=docid+util.getOption("accNumSeparator")+"1";
             //System.out.println("accnum: "+accnum);
-            DocumentImpl.delete(conn, accnum, null, null);
+            DocumentImpl.delete(accnum, null, null);
             MetacatReplication.replLog("doc " + docid + " deleted");
           }
         }//for delete docs
@@ -409,9 +416,11 @@
             sql.append("server like '").append(server).append("'");
             //System.out.println("sql: " + sql.toString());
             pstmt.close();
-            pstmt = conn.prepareStatement(sql.toString());
+            pstmt = dbConn.prepareStatement(sql.toString());
+            //increase usage count
+            dbConn.increaseUsageCount(1);
             pstmt.executeUpdate();
-            //conn.commit();
+            dbConn.commit();
             System.out.println("last_checked updated to " + datestr + " on " +
                             server);
           }
@@ -429,9 +438,16 @@
       try
       {
         pstmt.close();
-        util.returnConnection(conn);
-      }
-      catch(Exception ee) {}
+      }//try
+      catch(Exception ee) 
+      {
+        MetaCatUtil.debugMessage("Error in ReplicationHandler.update to close"+
+                                " pstmt: "+ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
     }//finally
   }//update
   
@@ -440,12 +456,13 @@
    */
   private void updateCatalog(Hashtable serverList)
   {
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
     try
     {
-      try
-      { //this connection is prone to error for some reason so we 
-        //try to connect it three times before quiting.
+      /*try
+      { 
         conn = util.openDBConnection();
       }
       catch(SQLException sqle)
@@ -467,7 +484,11 @@
                                sqleee.getMessage());
           }
         }
-      }
+      }*/
+      
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.updateCatalog");
+      serialNumber=dbConn.getCheckOutSerialNumber();
       String server;
       Enumeration keys = serverList.keys();
       while(keys.hasMoreElements())
@@ -521,7 +542,9 @@
             sql.append("target_doctype, public_id, system_id) values (?,?,?,");
             sql.append("?,?)");
             //System.out.println("sql: " + sql.toString());
-            PreparedStatement pstmt = conn.prepareStatement(sql.toString());
+            pstmt = dbConn.prepareStatement(sql.toString());
+            //increase usage count 1
+            dbConn.increaseUsageCount(1);
             pstmt.setString(1, (String)v.elementAt(0));
             pstmt.setString(2, (String)v.elementAt(1));
             pstmt.setString(3, (String)v.elementAt(2));
@@ -532,7 +555,7 @@
           }
         }
       }
-      conn.close();
+      //conn.close();
     }
     catch(Exception e)
     {
@@ -539,14 +562,23 @@
       System.out.println("error in ReplicationHandler.updateCatalog: " + 
                           e.getMessage());
       e.printStackTrace(System.out);
+    }//catch
+    finally
+    {
       try
       {
-        conn.close();
-      }
-      catch (Exception ee)
+        pstmt.close();
+      }//try
+      catch (SQLException ee)
       {
-      }
-    }
+        MetaCatUtil.debugMessage("Error in ReplicationHandler.updateCatalog "+
+                      "to close pstmt: "+ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finall
   }
   
   /**
@@ -560,10 +592,16 @@
    *   _             X             TRUE
    *   _             _             TRUE
    */
-  private static boolean alreadyDeleted(String docid, Connection conn)
+  private static boolean alreadyDeleted(String docid)
   {
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
     try
     {
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.alreadyDeleted");
+      serialNumber=dbConn.getCheckOutSerialNumber();
       boolean xml_docs = false;
       boolean xml_revs = false;
       
@@ -570,7 +608,7 @@
       StringBuffer sb = new StringBuffer();
       sb.append("select docid from xml_revisions where docid like '");
       sb.append(docid).append("'");
-      PreparedStatement pstmt = conn.prepareStatement(sb.toString());
+      pstmt = dbConn.prepareStatement(sb.toString());
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
       boolean tablehasrows = rs.next();
@@ -583,7 +621,9 @@
       sb.append("select docid from xml_documents where docid like '");
       sb.append(docid).append("'");
       pstmt.close();
-      pstmt = conn.prepareStatement(sb.toString());
+      pstmt = dbConn.prepareStatement(sb.toString());
+      //increase usage count
+      dbConn.increaseUsageCount(1);
       pstmt.execute();
       rs = pstmt.getResultSet();
       tablehasrows = rs.next();
@@ -618,8 +658,20 @@
     }
     finally
     {
-      
-    }
+      try
+      {
+        pstmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("Error in replicationHandler.alreadyDeleted "+
+                          "to close pstmt: "+ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
     return false;
   }
   
@@ -629,14 +681,20 @@
    */
   private static String getAction(String docid)
   {
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
     try
     {
-      MetaCatUtil util = new MetaCatUtil();
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.getAction");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      //MetaCatUtil util = new MetaCatUtil();
       StringBuffer sql = new StringBuffer();
       sql.append("select docid from xml_documents where docid like '");
       sql.append(docid).append("'");
-      Connection conn = util.openDBConnection();
-      PreparedStatement pstmt = conn.prepareStatement(sql.toString());
+      //Connection conn = util.openDBConnection();
+      pstmt = dbConn.prepareStatement(sql.toString());
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
 
@@ -643,13 +701,13 @@
       if(rs.next())
       {
         pstmt.close();
-        conn.close();
+        //conn.close();
         return "UPDATE";
       }
       else
       {
         pstmt.close();
-        conn.close();
+        //conn.close();
         return "INSERT";
       }
     }
@@ -658,6 +716,22 @@
       System.out.println("error in replicationHandler.getAction: " + 
                           e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }
+      catch (SQLException sqlE)
+      {
+        MetaCatUtil.debugMessage("error in replicationHandler.getAction: " + 
+                     "to close pstmt: "+ sqlE.getMessage(), 30);
+      }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }
+    }//finally
     return "";
   }
   
@@ -666,13 +740,18 @@
    * and it's last update time.
    * @param conn a connection to the database
    */
-  public static Hashtable buildServerList(Connection conn)
+  public static Hashtable buildServerList()
   {
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     Hashtable sl = new Hashtable();
-    PreparedStatement pstmt;   
+    PreparedStatement pstmt = null;   
     try
     {
-      pstmt = conn.prepareStatement("select server, last_checked, replicate " +
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.buildServerList");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement("select server, last_checked, replicate "+
                                     "from xml_replication");
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
@@ -697,6 +776,23 @@
       System.out.println("error in replicationHandler.buildServerList(): " +
                          e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      catch (SQLException sqlE)
+      {
+        MetaCatUtil.debugMessage("Error in ReplicationHandler.buildServerList: "
+                                +sqlE.getMessage());
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+     
     return sl;
   }
    /**
@@ -706,16 +802,20 @@
   public static Hashtable getHomeServer(String docId)
   {
     Hashtable sl = new Hashtable();
-    Connection conn = null;
-    MetaCatUtil ut=new MetaCatUtil();
-    docId=ut.getDocIdFromString(docId);
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    //MetaCatUtil ut=new MetaCatUtil();
+    docId=MetaCatUtil.getDocIdFromString(docId);
     PreparedStatement pstmt=null;
     int serverLocation;
     try
     {
-      conn=ut.getConnection();
+      //get conection
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.getHomeServer");
+      serialNumber=dbConn.getCheckOutSerialNumber();
       //get a server location from xml_document table
-      pstmt = conn.prepareStatement("select server_location from xml_documents "
+      pstmt=dbConn.prepareStatement("select server_location from xml_documents "
                                             +"where docid = ?");
       pstmt.setString(1, docId);
       pstmt.execute();
@@ -729,11 +829,13 @@
       else
       {
         pstmt.close();
-        ut.returnConnection(conn);
+        //ut.returnConnection(conn);
         return null;
       }
-      pstmt = conn.prepareStatement("select server, last_checked, replicate " +
+      pstmt=dbConn.prepareStatement("select server, last_checked, replicate " +
                         "from xml_replication where serverid = ?");
+      //increase usage count
+      dbConn.increaseUsageCount(1);
       pstmt.setInt(1, serverLocation);
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
@@ -752,7 +854,7 @@
       else
       {
         pstmt.close();
-        ut.returnConnection(conn);
+        //ut.returnConnection(conn);
         return null;
       }
       pstmt.close();
@@ -759,7 +861,7 @@
     }
     catch(Exception e)
     {
-      System.out.println("error in replicationHandler.buildServerList(): " +
+      System.out.println("error in replicationHandler.getHomeServer(): " +
                          e.getMessage());
     }
     finally
@@ -767,13 +869,19 @@
       try
       {
         pstmt.close();
-        ut.returnConnection(conn);
+        //ut.returnConnection(conn);
       }
       catch (Exception ee)
       {
+        MetaCatUtil.debugMessage("Eror irn rplicationHandler.getHomeServer() "+
+                          "to close pstmt: "+ee.getMessage(), 30);
       }
-      
-    }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }
+    
+    }//finally
     return sl;
   }
   
@@ -784,17 +892,22 @@
    */
   public static int getServerLocation(String accNum) throws Exception
   {
-    Connection conn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     PreparedStatement pstmt = null;
     int serverCode = 1;
-    MetaCatUtil ut = new MetaCatUtil();
-    String docId=ut.getDocIdFromString(accNum);
+    //MetaCatUtil ut = new MetaCatUtil();
+    String docId=MetaCatUtil.getDocIdFromString(accNum);
 
     try 
     {
 
-      conn = ut.openDBConnection();
-      pstmt = conn.prepareStatement("SELECT server_location FROM xml_documents " 
+      //conn = ut.openDBConnection();
+      //get conection
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.getServerLocation");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt=dbConn.prepareStatement("SELECT server_location FROM xml_documents " 
                               + "WHERE docid LIKE '" + docId + "'");
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
@@ -804,7 +917,7 @@
       {  
         serverCode = rs.getInt(1);
         pstmt.close();
-        conn.close();
+        //conn.close();
         return serverCode;
       }
       //if couldn't find in xml_documents table, we think server code is 1
@@ -812,7 +925,7 @@
       else
       {
         pstmt.close();
-        conn.close();
+        //conn.close();
         return serverCode;
       }
       
@@ -828,15 +941,20 @@
       try 
       {
         pstmt.close();
-        conn.close();
-        return serverCode;
+        //conn.close();
+        
       } 
       catch(Exception ee) 
       {
-        
+        MetaCatUtil.debugMessage("Erorr in Replication.getServerLocation "+
+                     "to close pstmt"+ee.getMessage(), 30);
       }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
     }//finally
-  
+   //return serverCode;
   }
   
   
Index: src/edu/ucsb/nceas/metacat/DBSAXNode.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 1217)
@@ -42,7 +42,7 @@
  */
 public class DBSAXNode extends BasicNode {
 
-  private Connection	conn;
+  private DBConnection	connection;
   private DBSAXNode	parentNode;
   private static final AbstractDatabase dbAdapter = MetaCatUtil.dbAdapter;
 
@@ -51,10 +51,10 @@
    *
    * @param conn the JDBC Connection to which all information is written
    */
-  public DBSAXNode (Connection conn, String docid) throws SAXException {
+  public DBSAXNode (DBConnection conn, String docid) throws SAXException {
 
     super();
-    this.conn = conn;
+    this.connection = conn;
     this.parentNode = null;
     writeChildNodeToDB("DOCUMENT", null, null, docid);
     updateRootNodeID(getNodeID());
@@ -67,13 +67,13 @@
    * @param tagname the name of the node
    * @param parentNode the parent node for this node being created
    */
-  public DBSAXNode (Connection conn, String qName, String lName,
+  public DBSAXNode (DBConnection conn, String qName, String lName,
                     DBSAXNode parentNode, long rootnodeid, 
                     String docid, String doctype) 
                                                throws SAXException {
 
     super(lName);
-    this.conn = conn;
+    this.connection = conn;
     this.parentNode = parentNode;
     setParentID(parentNode.getNodeID());
     setRootNodeID(rootnodeid);
@@ -89,7 +89,7 @@
                                  String data, String docid) 
                                  throws SAXException {
     try {
-      if(conn == null)
+      /*if(conn == null)
       {
         try
         {
@@ -101,21 +101,26 @@
           MetaCatUtil.debug("Error while getting db connection in " +
                             "DBSAXNode: " + e.getMessage());
         }
-      }
+      }*/
         
       PreparedStatement pstmt;
       if (nodetype == "DOCUMENT") {
-        pstmt = conn.prepareStatement(
+        pstmt = connection.prepareStatement(
             "INSERT INTO xml_nodes " +
             "(nodetype, nodename, nodeprefix, docid) " +
             "VALUES (?, ?, ?, ?)");
+        
+        // Increase DBConnection usage count
+        connection.increaseUsageCount(1);
         MetaCatUtil.debugMessage("INSERTING DOCNAME: " + nodename);
       } else {
-        pstmt = conn.prepareStatement(
+        pstmt = connection.prepareStatement(
             "INSERT INTO xml_nodes " +
             "(nodetype, nodename, nodeprefix, docid, " +
             "rootnodeid, parentnodeid, nodedata, nodeindex) " +
             "VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
+        // Increase DBConnection usage count
+        connection.increaseUsageCount(1);
       }
 
       // Bind the values to the query
@@ -150,7 +155,10 @@
       pstmt.close();
 
       // get the generated unique id afterward
-      long nid = dbAdapter.getUniqueID(conn, "xml_nodes");
+      long nid = dbAdapter.
+                         getUniqueID(connection.getConnections(), "xml_nodes");
+      //should incease connection usage!!!!!!
+     
       
       if (nodetype.equals("DOCUMENT")) {
         // Record the root node id that was generated from the database
@@ -184,9 +192,11 @@
   public void updateRootNodeID(long nodeid) throws SAXException {
       try {
         PreparedStatement pstmt;
-        pstmt = conn.prepareStatement(
+        pstmt = connection.prepareStatement(
               "UPDATE xml_nodes set rootnodeid = ? " +
               "WHERE nodeid = ?");
+        // Increase DBConnection usage count
+        connection.increaseUsageCount(1);
 
         // Bind the values to the query
         pstmt.setLong(1, nodeid);
@@ -208,9 +218,11 @@
   public void writeNodename(String nodename) throws SAXException {
       try {
         PreparedStatement pstmt;
-        pstmt = conn.prepareStatement(
+        pstmt = connection.prepareStatement(
               "UPDATE xml_nodes set nodename = ? " +
               "WHERE nodeid = ?");
+        // Increase DBConnection usage count
+        connection.increaseUsageCount(1);
 
         // Bind the values to the query
         pstmt.setString(1, nodename);
@@ -229,8 +241,13 @@
   private long generateNodeID() throws SAXException {
       long nid=0;
       Statement stmt;
+      DBConnection dbConn = null;
+      int serialNumber = -1;
       try {
-        stmt = conn.createStatement();
+        // Get DBConnection
+        dbConn=DBConnectionPool.getDBConnection("DBSAXNode.generateNodeID");
+        serialNumber=dbConn.getCheckOutSerialNumber();
+        stmt = dbConn.createStatement();
         stmt.execute("SELECT xml_nodes_id_seq.nextval FROM dual");
         ResultSet rs = stmt.getResultSet();
         boolean tableHasRows = rs.next();
@@ -243,6 +260,11 @@
                             e.getMessage());
         throw new SAXException(e.getMessage());
       }
+      finally
+      {
+        // Return DBconnection
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
 
       return nid;
   }
@@ -276,84 +298,8 @@
     }
   }
 
-  /** 
-   * NOT USED
-   * Update the node index (xml_index) for this node by generating
-   * test strings that represent all of the relative and absolute
-   * paths through the XML tree from document root to this node
-   */
-  private void updateNodeIndex(String docid, String doctype) 
-               throws SAXException
-  {
-    Hashtable pathlist = new Hashtable();
-    boolean atStartingNode = true;
-    boolean atRootDocumentNode = false;
-    DBSAXNode nodePointer = this;
-    StringBuffer currentPath = new StringBuffer();
-    int counter = 0;
+ 
 
-    // Create a Hashtable of all of the paths to reach this node
-    // including absolute paths and relative paths
-    while (!atRootDocumentNode) {
-      if (atStartingNode) {
-        currentPath.insert(0, nodePointer.getTagName());
-        pathlist.put(currentPath.toString(), new Long(getNodeID()));
-        counter++;
-        atStartingNode = false;
-      } else {
-        currentPath.insert(0, "/");
-        currentPath.insert(0, nodePointer.getTagName());
-        pathlist.put(currentPath.toString(), new Long(getNodeID()));
-        counter++;
-      }
-
-      // advance to the next parent node
-      nodePointer = nodePointer.getParentNode();
-
-      // If we're at the DOCUMENT node (root of DOM tree), add
-      // the root "/" to make the absolute path
-      if (nodePointer.getNodeType().equals("DOCUMENT")) {
-        currentPath.insert(0, "/");
-        pathlist.put(currentPath.toString(), new Long(getNodeID()));
-        counter++;
-        atRootDocumentNode = true;
-      } 
-    }
-
-    try {
-      // Create an insert statement to reuse for all of the path insertions
-      PreparedStatement pstmt = conn.prepareStatement(
-              "INSERT INTO xml_index (nodeid, path, docid, doctype, " + 
-               "parentnodeid) " + 
-              "VALUES (?, ?, ?, ?, ?)");
-      //((OraclePreparedStatement)pstmt).setExecuteBatch(counter);
-  
-      pstmt.setString(3, docid);
-      pstmt.setString(4, doctype);
-      pstmt.setLong(5, getParentID());
-      
-      // Step through the hashtable and insert each of the path values
-      Enumeration en = pathlist.keys();
-      while (en.hasMoreElements()) {
-        String path = (String)en.nextElement();
-        Long nodeid = (Long)pathlist.get(path);
-        pstmt.setLong(1, nodeid.longValue());
-        pstmt.setString(2, path);
-        pstmt.executeUpdate();
-  
-        //System.out.println(nodeid + " ==> " + path);
-      }
-
-      // Close the database statement
-      pstmt.close();
-    } catch (SQLException sqe) {
-      System.err.println("SQL Exception while inserting path to index in " + 
-                         "DBSAXNode.updateNodeIndex");
-      System.err.println(sqe.getMessage());
-      throw new SAXException(sqe.getMessage());
-    }
-  }
-
   /** 
    * USED FROM SEPARATE THREAD RUNNED from DBSAXHandler on endDocument()
    * Update the node index (xml_index) for this node by generating
@@ -360,7 +306,7 @@
    * test strings that represent all of the relative and absolute
    * paths through the XML tree from document root to this node
    */
-  public void updateNodeIndex(Connection conn, String docid, String doctype) 
+  public void updateNodeIndex(DBConnection conn, String docid, String doctype) 
                throws SAXException
   {
     Hashtable pathlist = new Hashtable();
@@ -404,6 +350,8 @@
               "INSERT INTO xml_index (nodeid, path, docid, doctype, " + 
                "parentnodeid) " + 
               "VALUES (?, ?, ?, ?, ?)");
+      // Increase usage count
+      conn.increaseUsageCount(1);
   
       pstmt.setString(3, docid);
       pstmt.setString(4, doctype);
Index: src/edu/ucsb/nceas/metacat/RelationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/RelationHandler.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/RelationHandler.java	(revision 1217)
@@ -27,7 +27,7 @@
 public class RelationHandler //implements Runnable
 {
   private Thread btThread = null;
-  private Connection conn = null;
+  private DBConnection connection = null;
   private String docid = null;
   MetaCatUtil util = new MetaCatUtil();
   
@@ -37,10 +37,10 @@
    * relations.
    * @param docid the ID of the XML document to index.
    */
-  public RelationHandler(String docid, Connection conn)
+  public RelationHandler(String docid, DBConnection conn)
               throws McdbException, SQLException, AccessionNumberException
   {
-    this.conn = conn;
+    this.connection = conn;
     this.docid = docid;
     putRelations();
   }
@@ -69,21 +69,26 @@
      */
 
     //DocumentImpl xmldoc = new DocumentImpl(conn,docid,false);
-    packagetype = (new DocumentImpl(conn,docid,false)).getDoctype();
+    packagetype = (new DocumentImpl(docid,false)).getDoctype();
 
     // first delete the relations for this package document if any
     deleteRelations(docid);
 
     // to put the new relations get them out of xml_nodes
-    pstmt = conn.prepareStatement(QuerySpecification.printPackageSQL(docid));
+    pstmt = connection.prepareStatement
+                                (QuerySpecification.printPackageSQL(docid));
+    //increase usage cont
+    connection.increaseUsageCount(1);
     pstmt.execute();
     ResultSet rs = pstmt.getResultSet();
     boolean hasmorerows = rs.next();
     if (hasmorerows) {
-      tstmt = conn.prepareStatement("INSERT INTO xml_relation (" +
+      tstmt = connection.prepareStatement("INSERT INTO xml_relation (" +
                                     "docid,packagetype,subject,subdoctype," +
                                     "relationship, object, objdoctype) " + 
                                     "VALUES (?, ?, ?, ?, ?, ?, ?)");
+      //increase usage count
+      connection.increaseUsageCount(1);
     }
     while(hasmorerows) {
       subject = rs.getString(1);
@@ -115,7 +120,7 @@
       tstmt.close();
     }
     pstmt.close();
-    conn.commit();
+    connection.commit();
   }
   
   /**
@@ -125,9 +130,11 @@
   public void deleteRelations(String docid) throws SQLException
   {
     try {
-      PreparedStatement pstmt = conn.prepareStatement(
+      PreparedStatement pstmt = connection.prepareStatement(
                                 "DELETE FROM xml_relation " +
                                 "WHERE docid = '" + docid + "'");
+      //increase usage count
+      connection.increaseUsageCount(1);
       pstmt.execute();
       pstmt.close();
     } catch(SQLException e) {
@@ -147,6 +154,9 @@
   public String getAccessFileID(String docid) throws SQLException
   {
     String aclid = null;
+    PreparedStatement pstmt = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     
     StringBuffer sql = new StringBuffer();
     sql.append("SELECT docid FROM xml_documents WHERE docid in (SELECT subject ");
@@ -176,14 +186,32 @@
     pstmt.setString(1, docid);
     pstmt.setString(2, MetaCatUtil.getOption("accessdoctype"));
     */
-    PreparedStatement pstmt = conn.prepareStatement(sql.toString());
-    pstmt.execute();
-    ResultSet rs = pstmt.getResultSet();
-    boolean hasRow = rs.next();
-    if (hasRow) {
-      aclid = rs.getString(1);
-    }
-    pstmt.close();
+    try
+    {
+      dbConn=DBConnectionPool.
+                  getDBConnection("RelationHandler.getAccessFileID");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement(sql.toString());
+      pstmt.execute();
+      ResultSet rs = pstmt.getResultSet();
+      boolean hasRow = rs.next();
+      if (hasRow) {
+        aclid = rs.getString(1);
+      }
+      pstmt.close();
+    }//try
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+     
     
     return aclid;
   }
